diff --git a/.gitignore b/.gitignore
index 5742907..f50a89d 100644
--- a/.gitignore
+++ b/.gitignore
@@ -32,14 +32,15 @@ tags
 lib/
 obj/
 build/
-test/example/odp_example
-test/packet/odp_packet
-test/packet_netmap/odp_packet_netmap
-test/api_test/odp_atomic
-test/api_test/odp_shm
-test/api_test/odp_ring
-test/api_test/odp_timer
-test/packet/odp_pktio
-test/timer/odp_timer_test
-test/generator/odp_generator
-test/l2fwd/odp_l2fwd
+odp_example
+odp_packet
+odp_packet_netmap
+odp_atomic
+odp_shm
+odp_ring
+odp_timer
+odp_pktio
+odp_timer_test
+odp_generator
+odp_l2fwd
+doxygen-doc
diff --git a/Makefile.am b/Makefile.am
index 36d5c23..551d1c2 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,7 +1,7 @@
 ACLOCAL_AMFLAGS=-I m4
 AUTOMAKE_OPTIONS = foreign
 
-SUBDIRS = platform test
+SUBDIRS = example platform test
 
 include $(top_srcdir)/aminclude.am
 
diff --git a/configure.ac b/configure.ac
index 873ea9e..a3f4a67 100644
--- a/configure.ac
+++ b/configure.ac
@@ -108,18 +108,19 @@ AC_FUNC_MMAP
 AC_CHECK_FUNCS([bzero clock_gettime gethostbyname getpagesize gettimeofday memset munmap socket strchr strerror strrchr strstr strtoull])
 
 AC_CONFIG_FILES([Makefile
-		 platform/Makefile
-		 platform/linux-generic/Makefile
-		 platform/linux-keystone2/Makefile
-		 test/Makefile
-		 test/api_test/Makefile
-		 test/example/Makefile
-		 test/generator/Makefile
-		 test/l2fwd/Makefile
-		 test/packet/Makefile
-		 test/packet_netmap/Makefile
-		 test/timer/Makefile
-		 pkgconfig/libodp.pc])
+     example/generator/Makefile
+     example/l2fwd/Makefile
+     example/Makefile
+     example/odp_example/Makefile
+     example/packet/Makefile
+     example/packet_netmap/Makefile
+     example/timer/Makefile
+     platform/linux-generic/Makefile
+     platform/linux-keystone2/Makefile
+     platform/Makefile
+     test/api_test/Makefile
+     test/Makefile
+     pkgconfig/libodp.pc])
 
 AC_SEARCH_LIBS([timer_create],[rt posix4])
 
diff --git a/doxygen.cfg b/doxygen.cfg
index 6c78712..ad1a8e8 100644
--- a/doxygen.cfg
+++ b/doxygen.cfg
@@ -9,7 +9,7 @@ TYPEDEF_HIDES_STRUCT = YES
 EXTRACT_STATIC = YES
 SORT_MEMBER_DOCS = NO
 WARN_NO_PARAMDOC = YES
-INPUT = $(SRCDIR)/doc $(SRCDIR)/include $(SRCDIR)/test
+INPUT = $(SRCDIR)/doc $(SRCDIR)/example $(SRCDIR)/include
 FILE_PATTERNS = odp*.h odp*.c *.dox
 RECURSIVE = YES
 SOURCE_BROWSER = YES
@@ -23,7 +23,7 @@ CLASS_DIAGRAMS = NO
 HAVE_DOT = YES
 CALL_GRAPH = YES
 DOT_MULTI_TARGETS = NO
-EXAMPLE_PATH = $(SRCDIR)/test
+EXAMPLE_PATH = $(SRCDIR)/example
 EXAMPLE_PATTERNS = *.c
 EXAMPLE_RECURSIVE = YES
 IMAGE_PATH = $(SRCDIR)/doc/images
diff --git a/example/Makefile.am b/example/Makefile.am
new file mode 100644
index 0000000..01a3305
--- /dev/null
+++ b/example/Makefile.am
@@ -0,0 +1 @@
+SUBDIRS = generator l2fwd odp_example packet packet_netmap timer
diff --git a/example/Makefile.inc b/example/Makefile.inc
new file mode 100644
index 0000000..b549001
--- /dev/null
+++ b/example/Makefile.inc
@@ -0,0 +1,10 @@
+include $(top_srcdir)/Makefile.inc
+LIB   = $(top_builddir)/lib
+LDADD = $(LIB)/libodp.la
+AM_CFLAGS += \
+	-I$(srcdir) \
+	-I$(top_srcdir)/platform/@with_platform@/include/api \
+	-I$(top_srcdir)/platform/linux-generic/include/api \
+	-I$(top_srcdir)/include
+
+AM_LDFLAGS += -L$(LIB)
diff --git a/example/README b/example/README
new file mode 100644
index 0000000..3f85969
--- /dev/null
+++ b/example/README
@@ -0,0 +1,3 @@
+Files in this directory are intended to be part of the ODP documentation.
+They should not introduce any Doxygen warnings or errors and will be
+part of the generated documentation.
diff --git a/test/generator/Makefile.am b/example/generator/Makefile.am
similarity index 100%
rename from test/generator/Makefile.am
rename to example/generator/Makefile.am
diff --git a/test/generator/odp_generator.c b/example/generator/odp_generator.c
similarity index 100%
rename from test/generator/odp_generator.c
rename to example/generator/odp_generator.c
diff --git a/test/l2fwd/Makefile.am b/example/l2fwd/Makefile.am
similarity index 100%
rename from test/l2fwd/Makefile.am
rename to example/l2fwd/Makefile.am
diff --git a/test/l2fwd/odp_l2fwd.c b/example/l2fwd/odp_l2fwd.c
similarity index 99%
rename from test/l2fwd/odp_l2fwd.c
rename to example/l2fwd/odp_l2fwd.c
index 035f710..e331ff2 100644
--- a/test/l2fwd/odp_l2fwd.c
+++ b/example/l2fwd/odp_l2fwd.c
@@ -7,7 +7,7 @@
 /**
  * @file
  *
- * @example l2fwd.c  ODP basic forwarding application
+ * @example odp_l2fwd.c  ODP basic forwarding application
  */
 
 #include <stdlib.h>
diff --git a/test/example/Makefile.am b/example/odp_example/Makefile.am
similarity index 100%
rename from test/example/Makefile.am
rename to example/odp_example/Makefile.am
diff --git a/test/example/odp_example.c b/example/odp_example/odp_example.c
similarity index 100%
rename from test/example/odp_example.c
rename to example/odp_example/odp_example.c
diff --git a/test/packet/Makefile.am b/example/packet/Makefile.am
similarity index 100%
rename from test/packet/Makefile.am
rename to example/packet/Makefile.am
diff --git a/test/packet/odp_pktio.c b/example/packet/odp_pktio.c
similarity index 99%
rename from test/packet/odp_pktio.c
rename to example/packet/odp_pktio.c
index 91aa6d1..edf8cfd 100644
--- a/test/packet/odp_pktio.c
+++ b/example/packet/odp_pktio.c
@@ -7,7 +7,7 @@
 /**
  * @file
  *
- * @example odp_example_pktio.c  ODP basic packet IO loopback test application
+ * @example odp_pktio.c  ODP basic packet IO loopback test application
  */
 
 #include <stdlib.h>
diff --git a/test/packet_netmap/Makefile.am b/example/packet_netmap/Makefile.am
similarity index 100%
rename from test/packet_netmap/Makefile.am
rename to example/packet_netmap/Makefile.am
diff --git a/test/packet_netmap/odp_pktio_netmap.c b/example/packet_netmap/odp_pktio_netmap.c
similarity index 100%
rename from test/packet_netmap/odp_pktio_netmap.c
rename to example/packet_netmap/odp_pktio_netmap.c
diff --git a/test/timer/Makefile.am b/example/timer/Makefile.am
similarity index 100%
rename from test/timer/Makefile.am
rename to example/timer/Makefile.am
diff --git a/test/timer/odp_timer_test.c b/example/timer/odp_timer_test.c
similarity index 100%
rename from test/timer/odp_timer_test.c
rename to example/timer/odp_timer_test.c
diff --git a/test/Makefile.am b/test/Makefile.am
index bae381e..9bd7db1 100644
--- a/test/Makefile.am
+++ b/test/Makefile.am
@@ -1 +1 @@
-SUBDIRS = api_test example generator l2fwd packet packet_netmap timer
+SUBDIRS = api_test
diff --git a/test/README b/test/README
new file mode 100644
index 0000000..045f88b
--- /dev/null
+++ b/test/README
@@ -0,0 +1,2 @@
+Files in this directory are intended to be terse checks that help ensure
+that the ODP API Implementations all perform identically and to specification.